on launched theObject
	try
		do shell script "mkdir /tmp/Cocoapotrace"
	end try
end launched

on will quit theObject
	try
		do shell script "rm -r /tmp/Cocoapotrace"
	end try
end will quit


on awake from nib theObject
	if name of theObject is "bitmapview" then
		tell theObject to register drag types {"file names"}
	end if
end awake from nib

on drop theObject drag info dragInfo
	if name of theObject is "bitmapview" then
		set flg to true
		if "file names" is in types of pasteboard of dragInfo then
			set preferred type of pasteboard of dragInfo to "file names"
			set str1 to contents of pasteboard of dragInfo
			log str1
			set filepath to item 1 of str1
			try
				openimage(filepath)
			on error
				set flg to false
			end try
		else
			set flg to false
		end if
		return flg
	end if
end drop

on openimage(filepath)
	
	do shell script ("sips -s format bmp " & (quoted form of filepath) & " --out /tmp/Cocoapotrace/bitmap.bmp")
	
	do shell script ((quoted form of (getcmdpath() & "convert")) & " /tmp/Cocoapotrace/bitmap.bmp /tmp/Cocoapotrace/bitmap.bmp")
	
	tell progress indicator "potraceprogress" of window "Main" to start
	
	set img1 to load image ("/tmp/Cocoapotrace/bitmap.bmp")
	set image of image view "bitmapview" of window "Main" to img1
	set title of window "Main" to filepath
	set string value of text field "dropheretext" of window "Main" to ""
	
	process()
	
	tell progress indicator "potraceprogress" of window "Main" to stop
	set enabled of button "savebutton" of window "Main" to true
	set enabled of button "updatebutton" of window "Main" to true
	set enabled of button "previewbutton" of window "Main" to true
end openimage

on clicked theObject
	if name of theObject is "updatebutton" then
		tell progress indicator "potraceprogress" of window "Main" to start
		process()
		tell progress indicator "potraceprogress" of window "Main" to stop
	else if name of theObject is "previewbutton" then
		tell application "Preview"
			activate
			open file "/tmp/Cocoapotrace/preview.eps" as POSIX file
		end tell
	else if name of theObject is "algorithmrestorebutton" then
		tell box "algorithmbox" of window "Main"
			set current menu item of popup button "turnpolicybutton" to menu item 5 of popup button "turnpolicybutton"
			set state of button "longcurvebutton" to 1
			set string value of text field "turdsizevalue" to "2"
			set string value of text field "alphamaxvalue" to "1"
			set string value of text field "opttolerancevalue" to "0.2"
			set string value of text field "unitvalue" to "10"
		end tell
	else if name of theObject is "preprocessrestorebutton" then
		tell box "preprocessbox" of window "Main"
			set current menu item of popup button "scaleoptionbutton" to menu item 2 of popup button "scaleoptionbutton"
			set state of button "highpassbutton" to 0
			set state of button "scalebutton" to 0
			set state of button "thresholdbutton" to 0
			set string value of text field "highpassvalue" to "4"
			set string value of text field "scalevalue" to "2"
			set string value of text field "thresholdvalue" to "0.45"
		end tell
	else if name of theObject is "savebutton" then
		try
			set targetname to gettargetname(title of window "Main")
		on error
			set targetname to "vectorized.eps"
		end try
		set targetpath to POSIX path of (choose file name default name targetname)
		set cmd to "cp -f /tmp/Cocoapotrace/preview.eps " & (quoted form of targetpath)
		log cmd
		do shell script cmd
	else if name of theObject is "batchbutton" then
		display panel window "batchpanel" attached to window "Main"
	else if name of theObject is "batchcancelbutton" then
		close panel window "batchpanel"
	else if name of theObject is "batchokbutton" then
		batchprocess()
	else if name of theObject is "selectsourcefolderbutton" then
		choose folder
		set theFolder to result
		set contents of text field "sourcefoldertext" of box "sourcefolderbox" of window "batchpanel" to (POSIX path of theFolder)
		checkfolders()
	else if name of theObject is "selectdestfolderbutton" then
		choose folder
		set theFolder to result
		set contents of text field "destfoldertext" of box "destfolderbox" of window "batchpanel" to (POSIX path of theFolder)
		checkfolders()
	end if
end clicked

on read from file theObject of type ofType path name pathName
	set flg to true
	try
		openimage(pathName)
	on error
		set flg to false
	end try
	return flg
end read from file

on checkfolders()
	if contents of text field "sourcefoldertext" of box "sourcefolderbox" of window "batchpanel" is "" then
	else
		if contents of text field "destfoldertext" of box "destfolderbox" of window "batchpanel" is "" then
		else
			set enabled of button "batchokbutton" of window "batchpanel" to true
		end if
	end if
end checkfolders

on process()
	--generate command and run
	log "starting vectorization..."
	try
		
		set potracepath to quoted form of (getcmdpath() & "potrace")
		log potracepath
		
		if getpreprocesscmd() is "" then
			set cmd to potracepath & getoptions() & " /tmp/Cocoapotrace/bitmap.bmp -o /tmp/Cocoapotrace/preview.eps"
		else
			set cmd to getpreprocesscmd() & potracepath & getoptions() & " /tmp/Cocoapotrace/preprocess.pbm -o /tmp/Cocoapotrace/preview.eps"
		end if
		
		log cmd
		do shell script cmd
		
		set img1 to load image ("/tmp/Cocoapotrace/preview.eps")
		set image of image view "vectorizedview" of window "Main" to img1
		log "vectorization complete."
	on error
		log "vectorization failed."
		display dialog "An error occured during vectorization." & return & "Please check option values and retry."
	end try
end process

on batchprocess()
	try
		log "starting batch vectorization..."
		set potracepath to quoted form of (getcmdpath() & "potrace")
		set sourcefolder to contents of text field "sourcefoldertext" of box "sourcefolderbox" of window "batchpanel"
		set destfolder to contents of text field "destfoldertext" of box "destfolderbox" of window "batchpanel"
		set targetlist to (list folder file (sourcefolder as POSIX file))
		set n to (count targetlist)
		tell progress indicator "batchprogressindicator" of window "batchpanel" to start
		set i to 1
		repeat with obj in targetlist
			set sourcefilepath to quoted form of (sourcefolder & obj)
			log sourcefilepath
			set destfilepath to quoted form of (destfolder & gettargetname(obj))
			log destfilepath
			
			set contents of text field "batchstatustext" of window "batchpanel" to ("processing " & sourcefilepath)
			
			try
				do shell script ("sips -s format bmp " & sourcefilepath & " --out /tmp/Cocoapotrace/bitmap.bmp")
				
				do shell script ((quoted form of (getcmdpath() & "convert")) & " /tmp/Cocoapotrace/bitmap.bmp /tmp/Cocoapotrace/bitmap.bmp")
				
				if getpreprocesscmd() is "" then
					set cmd to potracepath & getoptions() & " /tmp/Cocoapotrace/bitmap.bmp -o " & destfilepath
				else
					set cmd to getpreprocesscmd() & potracepath & getoptions() & " /tmp/Cocoapotrace/preprocess.pbm -o " & destfilepath
				end if
				log cmd
				do shell script cmd
				set contents of progress indicator "batchprogressindicator" of window "batchpanel" to (i / n) * 100
				set i to i + 1
			end try
		end repeat
		tell progress indicator "batchprogressindicator" of window "batchpanel" to stop
		set contents of progress indicator "batchprogressindicator" of window "batchpanel" to 0
		log "batch vectorization complete."
		set contents of text field "batchstatustext" of window "batchpanel" to "complete."
	on error
		log "batch vectorization failed."
		display dialog "An error occured during batch vectorization." & return & "Please check option values and retry."
		set contents of text field "batchstatustext" of window "batchpanel" to "batch vectorization failed."
	end try
end batchprocess

on getcmdpath()
	--get path for Resources folder inside .app
	set cmdpath to POSIX path of (((path to me) as string) & "Contents:Resources:") as Unicode text
	return cmdpath
end getcmdpath

on getpreprocesscmd()
	--generate command for mkbitmap
	set preprocess to false
	tell box "preprocessbox" of window "Main"
		if state of button "highpassbutton" is 1 then
			set preprocess to true
			set highpass to (" -f " & string value of text field "highpassvalue")
		else
			set highpass to ""
		end if
		if state of button "scalebutton" is 1 then
			set preprocess to true
			tell popup button "scaleoptionbutton"
				set scaler to title of current menu item
				if scaler is "linear" then
					set scaleoption to " -1"
				else
					set scaleoption to " -3"
				end if
			end tell
			set scale to (" -s " & string value of text field "scalevalue" & scaleoption)
		else
			set scale to ""
		end if
		if state of button "thresholdbutton" is 1 then
			set preprocess to true
			set threshold to (" -t " & string value of text field "thresholdvalue")
		else
			set threshold to ""
		end if
	end tell
	if preprocess is true then
		set mkbitmappath to (getcmdpath() & "mkbitmap")
		set options to highpass & scale & threshold
		set preprocesscmd to mkbitmappath & " -x" & options & " /tmp/Cocoapotrace/bitmap.bmp -o /tmp/Cocoapotrace/preprocess.pbm;"
	else
		set preprocesscmd to ""
	end if
	log preprocesscmd
	return preprocesscmd
end getpreprocesscmd

on getoptions()
	--generate options for potrace
	tell box "algorithmbox" of window "Main"
		tell popup button "turnpolicybutton"
			set turnpolicy to title of current menu item
		end tell
		if state of button "longcurvebutton" is 0 then
			set longcurve to " -n"
		else
			set longcurve to ""
		end if
		set turdsize to string value of text field "turdsizevalue"
		set alphamax to string value of text field "alphamaxvalue"
		set opttolerance to string value of text field "opttolerancevalue"
		set unit to string value of text field "unitvalue"
	end tell
	
	set options to (" -z " & turnpolicy) & (" -t " & turdsize) & (" -a " & alphamax) & longcurve & (" -O " & opttolerance) & (" -u " & unit)
	log options
	return options
end getoptions

on gettargetname(targetname)
	set delim to AppleScript's text item delimiters
	set AppleScript's text item delimiters to "/"
	set str1 to text items of targetname
	set targetname to last item of str1
	set AppleScript's text item delimiters to "."
	set str1 to text items of targetname
	set n to count str1
	if n > 1 then
		set str1 to items 1 thru (n - 1) of str1
	end if
	set targetname to ((item 1 of str1) & ".eps")
	set AppleScript's text item delimiters to delim
	return targetname
end gettargetname